"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.commands = exports.executeCommand = exports.OrigeenError = void 0;
var setup_1 = require("./commands/setup");
var create_1 = require("./commands/create");
var open_1 = require("./commands/open");
var import_1 = require("./commands/import");
var delete_1 = require("./commands/delete");
var installTemplate_1 = require("./commands/installTemplate");
var deleteTemplate_1 = require("./commands/deleteTemplate");
var config_1 = require("./commands/config");
var projects_1 = require("./commands/projects");
var help_1 = require("./commands/help");
var OrigeenError = (function (_super) {
    __extends(OrigeenError, _super);
    function OrigeenError(message, advices) {
        var _this = _super.call(this, message) || this;
        _this.advices = advices;
        return _this;
    }
    return OrigeenError;
}(Error));
exports.OrigeenError = OrigeenError;
function executeCommand(commandName, args) {
    return __awaiter(this, void 0, void 0, function () {
        var command;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    command = exports.commands.find(function (cmd) { var _a; return cmd.name === commandName || ((_a = cmd.aliases) === null || _a === void 0 ? void 0 : _a.includes(commandName)); });
                    if (command == undefined) {
                        throw new OrigeenError("Unkwown command '" + commandName + "'", [
                            "Check the spelling",
                            "Run 'orgn' to list the available commands"
                        ]);
                    }
                    return [4, (command === null || command === void 0 ? void 0 : command.run(args))];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
exports.executeCommand = executeCommand;
exports.commands = [
    {
        name: "setup",
        description: "Launches the origeen setup process",
        run: function (args) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, setup_1.execute(args)];
                case 1: return [2, _a.sent()];
            }
        }); }); },
        usage: "setup",
    },
    {
        name: "projects",
        description: "Lists all your projects",
        run: function (args) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, projects_1.execute(args)];
        }); }); },
        usage: "projects",
    },
    {
        name: "create",
        description: "Creates a new project",
        run: function (args) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, create_1.execute(args)];
        }); }); },
        aliases: ["c"],
        usage: "create <projectName>",
    },
    {
        name: "open",
        description: "Opens a project with your favourite editor",
        run: function (args) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, open_1.execute(args)];
        }); }); },
        aliases: ["o"],
        usage: "open <projectName>",
    },
    {
        name: "import",
        description: "Imports an exisiting project into Origeen",
        run: function (args) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, import_1.execute(args)];
        }); }); },
        usage: "import <pathToProject>",
    },
    {
        name: "install-template",
        description: "Clones a GitHub repo or a folder to create a template",
        run: function (args) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, installTemplate_1.execute(args)];
        }); }); },
        aliases: ["it"],
        usage: "install-template [--local <pathToFolder> | --remote <urlToGitRepo>] [templateName]",
    },
    {
        name: "delete-template",
        description: "Deletes a previously installed template",
        run: function (args) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, deleteTemplate_1.execute(args)];
        }); }); },
        aliases: ["dt"],
        usage: "delete-template <templateName>",
    },
    {
        name: "delete",
        description: "Deletes a project from the disk",
        run: function (args) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, delete_1.execute(args)];
                case 1: return [2, _a.sent()];
            }
        }); }); },
        usage: "delete <projectName>",
    },
    {
        name: "config",
        description: "Get/Set values in the config file",
        run: function (args) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, config_1.execute(args)];
        }); }); },
        usage: "config [configName [--set <newConfigValue>] ]",
    },
    {
        name: "help",
        usage: "help",
        description: "Shows the help for orgn",
        run: function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, help_1.execute()];
        }); }); },
        aliases: ["h"],
    },
];
