"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.execute = void 0;
var underscore_string_1 = require("underscore.string");
var commands_1 = require("../commands");
var chalk_1 = __importDefault(require("chalk"));
var logs_1 = require("../logs");
function execute() {
    var log = console.log, group = console.group, groupEnd = console.groupEnd;
    log(chalk_1.default.underline("First, thanks for using Origeen !"));
    log();
    log("Origeen is a CLI-tool that helps you manage all your projects !");
    log();
    logs_1.h3("Usage :");
    log();
    log("  $ orgn <command> [--flags...]");
    log();
    logs_1.h3("Commands :");
    log();
    group();
    commands_1.commands.sort(function (a, b) {
        if (a.name < b.name)
            return -1;
        if (a.name > b.name)
            return 1;
        return 0;
    });
    for (var _i = 0, commands_2 = commands_1.commands; _i < commands_2.length; _i++) {
        var command = commands_2[_i];
        var dashNumber = 20 - command.name.length;
        log(command.name + " " + underscore_string_1.repeat(" ", dashNumber) + " " + command.description);
    }
    groupEnd();
}
exports.execute = execute;
