"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.execute = void 0;
var templates_1 = require("../templates");
var logs_1 = require("../logs");
var commands_1 = require("../commands");
function execute(args) {
    var _a, _b, _c;
    var error = console.error, log = console.log;
    logs_1.h1("Template install");
    var templateName = (_a = args._[1]) === null || _a === void 0 ? void 0 : _a.toString();
    if (templateName == undefined) {
        throw new commands_1.OrigeenError("You need to provide a template name that designate the template you're installing.", [
            "Specify the template name right after the command name"
        ]);
    }
    var localPath = (_b = args.local) !== null && _b !== void 0 ? _b : args.L;
    var remoteURL = (_c = args.remote) !== null && _c !== void 0 ? _c : args.R;
    if (localPath) {
        log("Creating template from local path:");
        log(localPath);
        log();
        templates_1.add(templateName, localPath, false);
        log("Done successfully !");
        return;
    }
    if (remoteURL) {
        log("Creating template from remote git repository:");
        log(remoteURL);
        log();
        templates_1.add(templateName, remoteURL, true);
        return;
    }
    throw new commands_1.OrigeenError("Origeen needs a source to create a template : either a local path or a remote URL.", [
        "Specify the '--local <localPath>' flag to copy a local folder",
        "Specify the '--remote <url>' flag to clone a remote git repository"
    ]);
}
exports.execute = execute;
