"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.execute = void 0;
var fs_extra_1 = __importDefault(require("fs-extra"));
var path_1 = __importDefault(require("path"));
var logs_1 = require("../logs");
var config_1 = require("../config");
function execute(args) {
    return __awaiter(this, void 0, void 0, function () {
        var clear, log, workspace, editor;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    clear = console.clear, log = console.log;
                    clear();
                    logs_1.h1("Setup Origeen");
                    log();
                    log();
                    log("Welcome to Origeen !");
                    log();
                    log("The next steps will help you configure Origeen as you wish.");
                    log("You only have to do it once !");
                    logs_1.h3("Workspace");
                    log("Your workspace is the place where live all your projects.");
                    log("This is the default location used by Origeen when creating a project.");
                    log();
                    log("Example : 'Z:/Users/JohnDoe/Code'");
                    log();
                    return [4, logs_1.ask("Workspace location? ", function (answer) {
                            if (answer == undefined)
                                return "A path cannot be an empty string";
                            if (answer == "")
                                return "A path cannot be an empty string";
                            var pathToWorkspace = path_1.default.resolve(process.cwd(), answer);
                            if (!fs_extra_1.default.existsSync(pathToWorkspace)) {
                                log("The path doesn't exist.");
                                log("Origeen will create it for you !");
                                fs_extra_1.default.mkdirSync(pathToWorkspace);
                            }
                            return undefined;
                        })];
                case 1:
                    workspace = _a.sent();
                    config_1.setProperty("workspace", workspace);
                    log("Your workspace is now initialized to :");
                    log(workspace);
                    log();
                    logs_1.h3("Editor");
                    log("Hopefully you have a text editor installed on your computer.");
                    log("Enter the path to its executable so that Origeen can open it for you !");
                    log();
                    return [4, logs_1.ask("Path to editor? ", function (answer) {
                            if (answer == undefined)
                                return "A path cannot be an empty string";
                            if (answer == "")
                                return "A path cannot be an empty string";
                            var pathToEditor = answer;
                            if (!fs_extra_1.default.existsSync(pathToEditor)) {
                                return "This isn't a valid path, you probably misspelled it.";
                            }
                            return undefined;
                        })];
                case 2:
                    editor = _a.sent();
                    config_1.setProperty("editorPath", editor);
                    log("Editor path set to :");
                    log(editor);
                    log();
                    log();
                    log("You can (re-)configure all of these settings by typing :");
                    logs_1.bashBlock("config <projectName> --set <newValue>");
                    logs_1.h1("Enjoy with Origeen !");
                    log();
                    log("And by the way, report issues at :");
                    log(logs_1.link("https://github.com/MartinHeywang/origeen/issues/new/choose"));
                    return [2];
            }
        });
    });
}
exports.execute = execute;
