"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.booleanValidator = exports.ask = exports.link = exports.bashBlock = exports.bash = exports.h3 = exports.h1 = exports.setup = exports.LogLevel = void 0;
var chalk_1 = __importDefault(require("chalk"));
var stdio_1 = require("stdio");
var LogLevel;
(function (LogLevel) {
    LogLevel["ERROR"] = "ERROR";
    LogLevel["WARNING"] = "WARNING";
    LogLevel["INFO"] = "INFO";
    LogLevel["DEBUG"] = "DEBUG";
})(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
var groupIndent = "";
function setup(logLevel) {
    var ERROR = LogLevel.ERROR, WARNING = LogLevel.WARNING, INFO = LogLevel.INFO;
    console.error = function (message) {
        if (message === void 0) { message = ""; }
        process.stdout.write("[" + chalk_1.default.red("ERROR") + "]   " + groupIndent + message + "\n");
    };
    console.warn = function (message) {
        if (message === void 0) { message = ""; }
        if (logLevel === ERROR)
            return;
        process.stdout.write("[" + chalk_1.default.yellow("WARNING") + "] " + groupIndent + message + "\n");
    };
    console.log = function (message) {
        if (message === void 0) { message = ""; }
        if (logLevel === ERROR)
            return;
        if (logLevel === WARNING)
            return;
        process.stdout.write("[" + chalk_1.default.blue("INFO") + "]    " + groupIndent + message + "\n");
    };
    console.debug = function (message) {
        if (message === void 0) { message = ""; }
        if (logLevel === ERROR)
            return;
        if (logLevel === WARNING)
            return;
        if (logLevel === INFO)
            return;
        process.stdout.write("[" + chalk_1.default.cyan("DEBUG") + "]   " + groupIndent + message + "\n");
    };
    console.group = function () {
        groupIndent += "    ";
    };
    console.groupEnd = function () {
        groupIndent = groupIndent.substring(4);
    };
}
exports.setup = setup;
function h1(message) {
    console.log(chalk_1.default.bold.yellow(message.toUpperCase()));
    console.log();
}
exports.h1 = h1;
function h3(message) {
    console.log();
    console.log(chalk_1.default.bold("## " + message.toUpperCase()));
    console.log();
}
exports.h3 = h3;
function bash(bash, internal) {
    if (internal === void 0) { internal = true; }
    return "`" + (internal && " orgn") + " " + bash + "`";
}
exports.bash = bash;
function bashBlock(bash, internal) {
    if (internal === void 0) { internal = true; }
    console.log();
    console.log("  $" + (internal && " orgn") + " " + bash);
    console.log();
}
exports.bashBlock = bashBlock;
function link(url) {
    return chalk_1.default.blue.underline(url);
}
exports.link = link;
function ask(question, validate) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2, new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                    var answer, message;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                answer = "";
                                _a.label = 1;
                            case 1:
                                if (!true) return [3, 3];
                                return [4, stdio_1.ask("[" + chalk_1.default.magenta("WAIT") + "]    " + question)];
                            case 2:
                                answer = _a.sent();
                                message = validate(answer);
                                if (message == undefined) {
                                    resolve(answer);
                                    return [3, 3];
                                }
                                console.warn(message);
                                return [3, 1];
                            case 3: return [2];
                        }
                    });
                }); })];
        });
    });
}
exports.ask = ask;
var booleanValidator = function (answer) {
    var answers = ["y", "n", "yes", "no"];
    if (!answers.includes(answer.toLowerCase())) {
        return "This is not a valid answer. Please type one of: '" + answers.join(", ") + "'";
    }
    return undefined;
};
exports.booleanValidator = booleanValidator;
