"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ensure = exports.EMPTY_TEMPLATE = exports.TEMPLATES = exports.PROJECTS = exports.CONFIG = exports.HOME = void 0;
var path_1 = __importDefault(require("path"));
var fs_extra_1 = __importDefault(require("fs-extra"));
exports.HOME = path_1.default.join(process.env.APPDATA ||
    (process.platform === "darwin"
        ? process.env.HOME + "/Library/Preferences"
        : process.env.HOME + "/.local/share"), "origeen");
exports.CONFIG = path_1.default.join(exports.HOME, "config.json");
exports.PROJECTS = path_1.default.join(exports.HOME, "projects.json");
exports.TEMPLATES = path_1.default.join(exports.HOME, "templates");
exports.EMPTY_TEMPLATE = path_1.default.join(exports.TEMPLATES, "@empty");
function ensure() {
    console.debug("Origeen's home:");
    console.debug(exports.HOME);
    console.debug();
    fs_extra_1.default.ensureDirSync(exports.HOME);
    if (!fs_extra_1.default.existsSync(exports.CONFIG))
        fs_extra_1.default.writeJsonSync(exports.CONFIG, {});
    if (!fs_extra_1.default.existsSync(exports.PROJECTS))
        fs_extra_1.default.writeJsonSync(exports.PROJECTS, []);
    fs_extra_1.default.ensureDirSync(exports.TEMPLATES);
    fs_extra_1.default.emptyDirSync(exports.EMPTY_TEMPLATE);
}
exports.ensure = ensure;
