export interface Project {
    name: string;
    path: string;
    createdAt?: number;
    importedAt?: number;
    lastOpenedAt: number;
    openings: number;
}
export declare function getProjects(): Project[];
export declare function projectExists(projectName: string): boolean;
export declare function isValidName(projectName: string): boolean;
export declare function getProject(projectName: string): Project;
export declare function createProject(projectName: string, templateName?: string): void;
export declare function openProject(projectName: string): void;
export declare function importProject(pathToProject: string): void;
export declare function deleteProject(projectName: string): Promise<void>;
